Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34921)
@@ -3682,7 +6094,9 @@
 
         my ($val, $subdir, $wrongFormat);
-        if ($tagID > 0xf000 and $tagTablePtr eq \%Image::ExifTool::Exif::Main) {
+        if ($tagID > 0xf000 and $isExif) {
             my $oldInfo = $$tagTablePtr{$tagID};
-            if (not $oldInfo or (ref $oldInfo eq 'HASH' and $$oldInfo{Condition})) {
+            if ((not $oldInfo or (ref $oldInfo eq 'HASH' and $$oldInfo{Condition} and
+                not $$oldInfo{PSRaw})) and not $bad)
+            {
                 # handle special case of Photoshop RAW tags (0xfde8-0xfe58)
                 # --> generate tags from the value if possible
@@ -3696,7 +6110,9 @@
                         $tagInfo = {
                             Name => $tag,
-                            ValueConv => '$_=$val;s/.*: //;$_', # remove descr
+                            Condition => '$$self{TIFF_TYPE} ne "DCR"',
+                            ValueConv => '$_=$val;s/^.*: //;$_', # remove descr
+                            PSRaw => 1, # (just as flag to avoid adding this again)
                         };
-                        Image::ExifTool::AddTagToTable($tagTablePtr, $tagID, $tagInfo);
+                        AddTagToTable($tagTablePtr, $tagID, $tagInfo);
                         # generate conditional list if a conditional tag already existed
                         $$tagTablePtr{$tagID} = [ $oldInfo, $tagInfo ] if $oldInfo;
@@ -3706,24 +6122,33 @@
         }
         if (defined $tagInfo and not $tagInfo) {
-            # GetTagInfo() required the value for a Condition
-            my $tmpVal = substr($$valueDataPt, $valuePtr, $readSize < 128 ? $readSize : 128);
-            # (use original format name in this call -- $formatStr may have been changed to int8u)
-            $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID, \$tmpVal,
-                                             $formatName[$format], $count);
+            if ($bad) {
+                undef $tagInfo;
+            } else {
+                # GetTagInfo() required the value for a Condition
+                my $tmpVal = substr($$valueDataPt, $valuePtr, $readSize < 128 ? $readSize : 128);
+                # (use original format name in this call -- $formatStr may have been changed to int8u)
+                $tagInfo = $et->GetTagInfo($tagTablePtr, $tagID, \$tmpVal,
+                                           $formatName[$format], $count);
+            }
         }
         # make sure we are handling the 'ifd' format properly
         if (($format == 13 or $format == 18) and (not $tagInfo or not $$tagInfo{SubIFD})) {
             my $str = sprintf('%s tag 0x%.4x IFD format not handled', $dirName, $tagID);
-            $exifTool->Warn($str, $inMakerNotes);
+            $et->Warn($str, $inMakerNotes);
         }
         if (defined $tagInfo) {
+            my $readFormat = $$tagInfo{Format};
             $subdir = $$tagInfo{SubDirectory};
+            # unless otherwise specified, all SubDirectory data except
+            # EXIF SubIFD offsets should be unformatted
+            $readFormat = 'undef' if $subdir and not $$tagInfo{SubIFD} and not $readFormat;
             # override EXIF format if specified
-            if ($$tagInfo{Format}) {
-                $formatStr = $$tagInfo{Format};
+            if ($readFormat) {
+                $formatStr = $readFormat;
                 my $newNum = $formatNumber{$formatStr};
                 if ($newNum and $newNum != $format) {
                     $origFormStr = $formatName[$format] . '[' . $count . ']';
                     $format = $newNum;
+                    $size = $readSize = $$tagInfo{FixedSize} if $$tagInfo{FixedSize};
                     # adjust number of items for new format size
                     $count = int($size / $formatSize[$format]);
@@ -3732,5 +6157,9 @@
             # verify that offset-type values are integral
             if (($$tagInfo{IsOffset} or $$tagInfo{SubIFD}) and not $intFormat{$formatStr}) {
-                $exifTool->Warn("Wrong format ($formatStr) for $name $$tagInfo{Name}");
+                $et->Warn(sprintf('Wrong format (%s) for %s 0x%.4x %s',$formatStr,$dir,$tagID,$$tagInfo{Name}));
+                if ($validate) {
+                    $$et{WrongFormat}{"$dir:$$tagInfo{Name}"} = 1;
+                    $offsetInfo{$tagID} = [ $tagInfo, '' ];
+                }
                 next unless $verbose;
                 $wrongFormat = 1;
@@ -3739,15 +6168,24 @@
             next unless $verbose;
         }
-        # convert according to specified format
-        $val = ReadValue($valueDataPt,$valuePtr,$formatStr,$count,$readSize);
+        unless ($bad) {
+            # limit maximum length of data to reformat
+            # (avoids long delays when processing some corrupted files)
+            if ($count > 100000 and $formatStr !~ /^(undef|string|binary)$/) {
+                my $tagName = $tagInfo ? $$tagInfo{Name} : sprintf('tag 0x%.4x', $tagID);
+                if ($tagName ne 'TransferFunction' or $count != 196608) {
+                    my $minor = $count > 2000000 ? 0 : 2;
+                    next if $et->Warn("Ignoring $dirName $tagName with excessive count", $minor);
+                }
+            }
+            # convert according to specified format
+            $val = ReadValue($valueDataPt,$valuePtr,$formatStr,$count,$readSize,\$rational);
+            # re-code if necessary
+            $val = $et->Decode($val, $strEnc) if $strEnc and $formatStr eq 'string' and defined $val;
+        }
 
         if ($verbose) {
             my $tval = $val;
-            if ($formatStr =~ /^rational64([su])$/ and defined $tval) {
-                # show numerator/denominator separately
-                my $f = ReadValue($valueDataPt,$valuePtr,"int32$1",$count*2,$readSize);
-                $f =~ s/(-?\d+) (-?\d+)/$1\/$2/g;
-                $tval .= " ($f)";
-            }
+            # also show as a rational
+            $tval .= " ($rational)" if defined $rational;
             if ($htmlDump) {
                 my ($tagName, $colName);
@@ -3759,5 +6197,5 @@
                     $tagName = sprintf("Tag 0x%.4x",$tagID);
                 }
-                my $dname = sprintf("${name}-%.2d", $index);
+                my $dname = sprintf("${dir}-%.2d", $index);
                 # build our tool tip
                 $size < 0 and $size = $count * $formatSize[$format];
@@ -3769,8 +6207,9 @@
                 if ($size > 4) {
                     my $offPt = Get32u($dataPt,$entry+8);
-                    my $actPt = $valuePtr + $valueDataPos + $base - ($$exifTool{EXIF_POS} || 0);
+                    # (test this with ../pics/{CanonEOS-1D_XMarkIII.hif,PanasonicDC-G9.rw2})
+                    my $actPt = $valuePtr + $valueDataPos + $base - ($$et{EXIF_POS} || 0) + ($$et{BASE_FUDGE} || 0);
                     $tip .= sprintf("Value offset: 0x%.4x\n", $offPt);
                     # highlight tag name (red for bad size)
-                    my $style = ($valueDataLen < 0 or not defined $tval) ? 'V' : 'H';
+                    my $style = ($bad or not defined $tval) ? 'V' : 'H';
                     if ($actPt != $offPt) {
                         $tip .= sprintf("Actual offset: 0x%.4x\n", $actPt);
@@ -3778,4 +6217,7 @@
                         $tip .= sprintf("Offset base: ${sign}0x%.4x\n", abs($actPt - $offPt));
                         $style = 'F' if $style eq 'H';  # purple for different offsets
+                    }
+                    if ($$et{EXIF_POS} and not $$et{BASE_FUDGE}) {
+                        $tip .= sprintf("File offset:   0x%.4x\n", $actPt + $$et{EXIF_POS})
                     }
                     $colName = "<span class=$style>$tagName</span>";
@@ -3785,6 +6227,8 @@
                 }
                 $colName .= ' <span class=V>(err)</span>' if $wrongFormat;
-                if ($valueDataLen < 0 or not defined $tval) {
-                    $tval = '<bad offset>';
+                $colName .= ' <span class=V>(seq)</span>' if $tagID <= $lastID and not $inMakerNotes;
+                $lastID = $tagID;
+                if (not defined $tval) {
+                    $tval = '<bad size/offset>';
                 } else {
                     $tval = substr($tval,0,28) . '[...]' if length($tval) > 32;
@@ -3795,5 +6239,5 @@
                         if ($$tagInfo{IsOffset} or $$tagInfo{SubIFD}) {
                             $tval = sprintf('0x%.4x', $tval);
-                            my $actPt = $val + $base - ($$exifTool{EXIF_POS} || 0);
+                            my $actPt = $val + $base - ($$et{EXIF_POS} || 0) + ($$et{BASE_FUDGE} || 0);
                             if ($actPt != $val) {
                                 $tval .= sprintf("\nActual offset: 0x%.4x", $actPt);
@@ -3807,5 +6251,8 @@
                 }
                 $tip .= "Value: $tval";
-                $exifTool->HDump($entry+$dataPos+$base, 12, "$dname $colName", $tip, 1);
+                my $id = $offName;
+                my $sid;
+                ($subOffName, $id, $sid) = NextOffsetName($et, $offName) if $tagInfo and $$tagInfo{SubIFD};
+                $et->HDump($entry+$dataPos+$base, 12, "$dname $colName", $tip, 1, $id);
                 next if $valueDataLen < 0;  # don't process bad pointer entry
                 if ($size > 4) {
@@ -3820,20 +6267,31 @@
                     }
                     # add value data block (underlining maker notes data)
-                    $exifTool->HDump($exifDumpPos,$size,"$tagName value",'SAME', $flag);
+                    $et->HDump($exifDumpPos,$size,"$tagName value",'SAME', $flag, $sid);
                 }
             } else {
-                my $fstr = $formatName[$format];
-                $fstr = "$origFormStr read as $fstr" if $origFormStr;
-                $exifTool->VerboseInfo($tagID, $tagInfo,
-                    Table   => $tagTablePtr,
-                    Index   => $index,
-                    Value   => $tval,
-                    DataPt  => $valueDataPt,
-                    DataPos => $valueDataPos + $base,
-                    Size    => $size,
-                    Start   => $valuePtr,
-                    Format  => $fstr,
-                    Count   => $count,
-                );
+                if ($tagID <= $lastID and not $inMakerNotes) {
+                    my $str = $tagInfo ? ' '.$$tagInfo{Name} : '';
+                    if ($tagID == $lastID) {
+                        $et->Warn(sprintf('Duplicate tag 0x%.4x%s in %s', $tagID, $str, $dirName));
+                    } else {
+                        $et->Warn(sprintf('Tag ID 0x%.4x%s out of sequence in %s', $tagID, $str, $dirName));
+                    }
+                }
+                $lastID = $tagID;
+                if ($verbose > 0) {
+                    my $fstr = $formatName[$format];
+                    $fstr = "$origFormStr read as $fstr" if $origFormStr;
+                    $et->VerboseInfo($tagID, $tagInfo,
+                        Table   => $tagTablePtr,
+                        Index   => $index,
+                        Value   => $tval,
+                        DataPt  => $valueDataPt,
+                        DataPos => $valueDataPos + $base,
+                        Size    => $size,
+                        Start   => $valuePtr,
+                        Format  => $fstr,
+                        Count   => $count,
+                    );
+                }
             }
             next if not $tagInfo or $wrongFormat;
@@ -3847,5 +6305,5 @@
             unless ($size) {
                 unless ($$tagInfo{MakerNotes} or $inMakerNotes) {
-                    $exifTool->Warn("Empty $$tagInfo{Name} data", 1);
+                    $et->Warn("Empty $$tagInfo{Name} data", 1);
                 }
                 next;
@@ -3858,6 +6316,6 @@
                 my $over = @values - $$subdir{MaxSubdirs};
                 if ($over > 0) {
-                    $exifTool->Warn("Ignoring $over $tagStr directories");
-                    pop @values while $over--;
+                    $et->Warn("Ignoring $over $tagStr directories");
+                    splice @values, $$subdir{MaxSubdirs};
                 }
                 $val = shift @values;
@@ -3882,11 +6340,13 @@
                     my $newStart = eval($$subdir{Start});
                     unless (Image::ExifTool::IsInt($newStart)) {
-                        $exifTool->Warn("Bad value for $tagStr");
+                        $et->Warn("Bad value for $tagStr");
                         last;
                     }
                     # convert back to relative to $subdirDataPt
                     $newStart -= $subdirDataPos;
-                    # must adjust directory size if start changed
-                    $size -= $newStart - $subdirStart unless $$subdir{BadOffset};
+                    # adjust directory size if necessary
+                    unless ($$tagInfo{SubIFD} or $$subdir{BadOffset}) {
+                        $size -= $newStart - $subdirStart;
+                    }
                     $subdirStart = $newStart;
                 }
@@ -3906,5 +6366,5 @@
                     } elsif ($subdirStart + 2 <= $subdirDataLen) {
                         # attempt to determine the byte ordering by checking
-                        # at the number of directory entries.  This is an int16u
+                        # the number of directory entries.  This is an int16u
                         # that should be a reasonable value.
                         my $num = Get16u($subdirDataPt, $subdirStart);
@@ -3932,5 +6392,5 @@
                     my $pos = eval $$subdir{OffsetPt};
                     if ($pos + 4 > $subdirDataLen) {
-                        $exifTool->Warn("Bad $tagStr OffsetPt");
+                        $et->Warn("Bad $tagStr OffsetPt");
                         last;
                     }
@@ -3956,5 +6416,5 @@
                             }
                         }
-                        $exifTool->Warn($msg);
+                        $et->Warn($msg, $inMakerNotes);
                         last;
                     }
@@ -3982,9 +6442,10 @@
                     SubIFD     => $$tagInfo{SubIFD},
                     Subdir     => $subdir,
+                    OffsetName => $subOffName,
                 );
                 # (remember: some cameras incorrectly write maker notes in IFD0)
                 if ($$tagInfo{MakerNotes}) {
                     # don't parse makernotes if FastScan > 1
-                    my $fast = $exifTool->Options('FastScan');
+                    my $fast = $et->Options('FastScan');
                     last if $fast and $fast > 1;
                     $subdirInfo{MakerNoteAddr} = $valuePtr + $valueDataPos + $base;
@@ -3992,8 +6453,8 @@
                 }
                 # set directory IFD name from group name of family 1 if it exists,
-                # unless the tag is extracted as a block in which case group 1 may
-                # have been set automatically if the block was previously extracted
-                if ($$tagInfo{Groups} and not $$tagInfo{BlockExtract}) {
-                    $subdirInfo{DirName} = $tagInfo->{Groups}{1};
+                # unless the tag is writable as a block in which case group 1 may
+                # have been set automatically
+                if ($$tagInfo{Groups} and not $$tagInfo{Writable}) {
+                    $subdirInfo{DirName} = $$tagInfo{Groups}{1};
                     # number multiple subdirectories
                     $subdirInfo{DirName} =~ s/\d*$/$dirNum/ if $dirNum;
@@ -4005,14 +6466,17 @@
                 my $ok = 0;
                 if (defined $$subdir{Validate} and not eval $$subdir{Validate}) {
-                    $exifTool->Warn("Invalid $tagStr data");
+                    $et->Warn("Invalid $tagStr data");
                     $invalid = 1;
                 } else {
+                    if (not $subdirInfo{DirName} and $inMakerNotes) {
+                        $subdirInfo{DirName} = $$tagInfo{Name};
+                    }
                     # process the subdirectory
-                    $ok = $exifTool->ProcessDirectory(\%subdirInfo, $newTagTable, $$subdir{ProcessProc});
+                    $ok = $et->ProcessDirectory(\%subdirInfo, $newTagTable, $$subdir{ProcessProc});
                 }
                 # print debugging information if there were errors
                 if (not $ok and $verbose > 1 and $subdirStart != $valuePtr) {
-                    my $out = $exifTool->Options('TextOut');
-                    printf $out "%s    (SubDirectory start = 0x%x)\n", $exifTool->{INDENT}, $subdirStart;
+                    my $out = $et->Options('TextOut');
+                    printf $out "%s    (SubDirectory start = 0x%x)\n", $$et{INDENT}, $subdirStart;
                 }
                 SetByteOrder($oldByteOrder);    # restore original byte swapping
@@ -4021,20 +6485,19 @@
                 $val = shift @values;           # continue with next subdir
             }
-            my $doMaker = $exifTool->Options('MakerNotes');
-            next unless $doMaker or $exifTool->{REQ_TAG_LOOKUP}{lc($tagStr)} or
-                        $$tagInfo{BlockExtract};
+            my $doMaker = $et->Options('MakerNotes');
+            next unless $doMaker or $$et{REQ_TAG_LOOKUP}{lc($tagStr)} or $$tagInfo{BlockExtract};
             # extract as a block if specified
             if ($$tagInfo{MakerNotes}) {
                 # save maker note byte order (if it was significant and valid)
                 if ($$subdir{ByteOrder} and not $invalid) {
-                    $exifTool->{MAKER_NOTE_BYTE_ORDER} =
-                        defined ($exifTool->{UnknownByteOrder}) ?
-                                 $exifTool->{UnknownByteOrder} : $newByteOrder;
+                    $$et{MAKER_NOTE_BYTE_ORDER} =
+                        defined ($$et{UnknownByteOrder}) ?
+                                 $$et{UnknownByteOrder} : $newByteOrder;
                 }
                 if ($doMaker and $doMaker eq '2') {
                     # extract maker notes without rebuilding (no fixup information)
-                    delete $exifTool->{MAKER_NOTE_FIXUP};
-                } elsif (not $$tagInfo{NotIFD}) {
-                    # this is a pain, but we must rebuild EXIF-typemaker notes to
+                    delete $$et{MAKER_NOTE_FIXUP};
+                } elsif (not $$tagInfo{NotIFD} or $$tagInfo{IsPhaseOne}) {
+                    # this is a pain, but we must rebuild EXIF-type maker notes to
                     # include all the value data if data was outside the maker notes
                     my %makerDirInfo = (
@@ -4052,11 +6515,18 @@
                         TagInfo    => $tagInfo,
                     );
-                    $makerDirInfo{FixBase} = 1 if $$subdir{FixBase};
-                    # rebuild maker notes (creates $exifTool->{MAKER_NOTE_FIXUP})
-                    my $val2 = RebuildMakerNotes($exifTool, $newTagTable, \%makerDirInfo);
+                    my $val2;
+                    if ($$tagInfo{IsPhaseOne}) {
+                        $$et{DropTags} = 1;
+                        $val2 = Image::ExifTool::PhaseOne::WritePhaseOne($et, \%makerDirInfo, $newTagTable);
+                        delete $$et{DropTags};
+                    } else {
+                        $makerDirInfo{FixBase} = 1 if $$subdir{FixBase};
+                        # rebuild maker notes (creates $$et{MAKER_NOTE_FIXUP})
+                        $val2 = RebuildMakerNotes($et, \%makerDirInfo, $newTagTable);
+                    }
                     if (defined $val2) {
                         $val = $val2;
-                    } else {
-                        $exifTool->Warn('Error rebuilding maker notes (may be corrupt)');
+                    } elsif ($size > 4) {
+                        $et->Warn('Error rebuilding maker notes (may be corrupt)');
                     }
                 }
@@ -4068,11 +6538,11 @@
  #..............................................................................
         # convert to absolute offsets if this tag is an offset
-        #### eval IsOffset ($val, $exifTool)
+        #### eval IsOffset ($val, $et)
         if ($$tagInfo{IsOffset} and eval $$tagInfo{IsOffset}) {
             my $offsetBase = $$tagInfo{IsOffset} eq '2' ? $firstBase : $base;
-            $offsetBase += $$exifTool{BASE};
+            $offsetBase += $$et{BASE};
             # handle offsets which use a wrong base (Minolta A200)
             if ($$tagInfo{WrongBase}) {
-                my $self = $exifTool;
+                my $self = $et;
                 #### eval WrongBase ($self)
                 $offsetBase += eval $$tagInfo{WrongBase} || 0;
@@ -4084,10 +6554,25 @@
             $val = join(' ', @vals);
         }
+        if ($validate) {
+            if ($$tagInfo{OffsetPair}) {
+                $offsetInfo{$tagID} = [ $tagInfo, $val ];
+            } elsif ($saveForValidate{$tagID} and $isExif) {
+                $offsetInfo{$tagID} = $val;
+            }
+        }
         # save the value of this tag
-        $tagKey = $exifTool->FoundTag($tagInfo, $val);
-        # set the group 1 name for tags in specified tables
-        if (defined $tagKey and $$tagTablePtr{SET_GROUP1}) {
-            $exifTool->SetGroup($tagKey, $dirName);
+        $tagKey = $et->FoundTag($tagInfo, $val);
+        if (defined $tagKey) {
+            # set the group 1 name for tags in specified tables
+            $et->SetGroup($tagKey, $dirName) if $$tagTablePtr{SET_GROUP1};
+            # save original components of rational numbers (used when copying)
+            $$et{RATIONAL}{$tagKey} = $rational if defined $rational;
+            $$et{TAG_EXTRA}{$tagKey}{G6} = $saveFormat if $saveFormat;
         }
+    }
+
+    # validate image data offsets for this IFD
+    if ($validate and %offsetInfo) {
+        Image::ExifTool::Validate::ValidateOffsetInfo($et, \%offsetInfo, $$dirInfo{DirName}, $inMakerNotes)
     }
 
@@ -4105,12 +6590,13 @@
             my $ifdNum = $newDirInfo{DirName} =~ s/(\d+)$// ? $1 : 0;
             $newDirInfo{DirName} .= $ifdNum + 1;
+            $newDirInfo{OffsetName} = $nextOffName;
             # must validate SubIFD1 because the nextIFD pointer is invalid for some RAW formats
             if ($newDirInfo{DirName} ne 'SubIFD1' or ValidateIFD(\%newDirInfo)) {
-                $exifTool->{INDENT} =~ s/..$//; # keep indent the same
-                my $cur = pop @{$$exifTool{PATH}};
-                $exifTool->ProcessDirectory(\%newDirInfo, $tagTablePtr) or $success = 0;
-                push @{$$exifTool{PATH}}, $cur;
-            } elsif ($verbose or $exifTool->{TIFF_TYPE} eq 'TIFF') {
-                $exifTool->Warn('Ignored bad IFD linked from SubIFD');
+                $$et{INDENT} =~ s/..$//; # keep indent the same
+                my $cur = pop @{$$et{PATH}};
+                $et->ProcessDirectory(\%newDirInfo, $tagTablePtr) or $success = 0;
+                push @{$$et{PATH}}, $cur;
+            } elsif ($verbose or $$et{TIFF_TYPE} eq 'TIFF') {
+                $et->Warn('Ignored bad IFD linked from SubIFD');
             }
         }
@@ -4138,5 +6624,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -4149,5 +6635,5 @@
 =item L<http://www.exif.org/Exif2-2.PDF>
 
-=item L<http://www.cipa.jp/english/hyoujunka/kikaku/pdf/DC-008-2010_E.pdf>
+=item L<http://www.cipa.jp/std/documents/e/DC-008-2012_E.pdf>
 
 =item L<http://partners.adobe.com/asn/developer/pdfs/tn/TIFF6.pdf>
@@ -4184,4 +6670,8 @@
 
 =item L<http://tools.ietf.org/html/draft-ietf-fax-tiff-fx-extension1-01>
+
+=item L<http://wwwimages.adobe.com/www.adobe.com/content/dam/Adobe/en/devnet/cinemadng/pdfs/CinemaDNG_Format_Specification_v1_1.pdf>
+
+=item L<http://geotiff.maptools.org/spec/geotiffhome.html>
 
 =back
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/FITS.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/FITS.pm	(revision 34921)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/FITS.pm	(revision 34921)
@@ -0,0 +1,151 @@
+#------------------------------------------------------------------------------
+# File:         FITS.pm
+#
+# Description:  Read Flexible Image Transport System metadata
+#
+# Revisions:    2018/03/07 - P. Harvey Created
+#
+# References:   1) https://fits.gsfc.nasa.gov/fits_standard.html
+#------------------------------------------------------------------------------
+
+package Image::ExifTool::FITS;
+
+use strict;
+use vars qw($VERSION);
+use Image::ExifTool qw(:DataAccess :Utils);
+
+$VERSION = '1.01';
+
+# FITS tags (ref 1)
+%Image::ExifTool::FITS::Main = (
+    GROUPS => { 2 => 'Image' },
+    NOTES => q{
+        This table lists some standard Flexible Image Transport System (FITS) tags,
+        but ExifTool will extract any other tags found.  See
+        L<https://fits.gsfc.nasa.gov/fits_standard.html> for the specification.
+    },
+    TELESCOP => 'Telescope',
+    BACKGRND => 'Background',
+    INSTRUME => 'Instrument',
+    OBJECT   => 'Object',
+    OBSERVER => 'Observer',
+    DATE     => { Name => 'CreateDate', Groups => { 2 => 'Time' } },
+    AUTHOR   => { Name => 'Author',     Groups => { 2 => 'Author' } },
+    REFERENC => 'Reference',
+   'DATE-OBS'=> { Name => 'ObservationDate',    Groups => { 2 => 'Time' } },
+   'TIME-OBS'=> { Name => 'ObservationTime',    Groups => { 2 => 'Time' } },
+   'DATE-END'=> { Name => 'ObservationDateEnd', Groups => { 2 => 'Time' } },
+   'TIME-END'=> { Name => 'ObservationTimeEnd', Groups => { 2 => 'Time' } },
+    COMMENT  => 'Comment',
+    HISTORY  => 'History',
+);
+
+#------------------------------------------------------------------------------
+# Read information in a FITS document
+# Inputs: 0) ExifTool ref, 1) dirInfo ref
+# Returns: 1 on success, 0 if this wasn't a valid FITS file
+sub ProcessFITS($$)
+{
+    my ($et, $dirInfo) = @_;
+    my $raf = $$dirInfo{RAF};
+    my ($buff, $tag, $continue);
+
+    return 0 unless $raf->Read($buff, 80) == 80 and $buff =~ /^SIMPLE  = {20}T/;
+    $et->SetFileType();
+    my $tagTablePtr = GetTagTable('Image::ExifTool::FITS::Main');
+
+    for (;;) {
+        $raf->Read($buff, 80) == 80 or $et->Warn('Truncated FITS header'), last;
+        my $key = substr($buff, 0, 8);
+        $key =~ s/ +$//;    # remove trailing space from key
+        if ($key eq 'CONTINUE') {
+            defined $continue or $et->WarnOnce('Unexpected FITS CONTINUE keyword'), next;
+        } else {
+            if (defined $continue) {
+                # the previous value wasn't continued, so store with the trailing '&'
+                $et->HandleTag($tagTablePtr, $tag, $continue . '&');
+                undef $continue;
+            }
+            last if $key eq 'END';
+            # make sure the key is valid
+            $key =~ /^[-_A-Z0-9]*$/ or $et->Warn('Format error in FITS header'), last;
+            # ignore lines other than tags, COMMENT or HISTORY
+            next unless substr($buff,8,2) eq '= ' or $key eq 'COMMENT' or $key eq 'HISTORY';
+            # save tag name (avoiding potential conflict with ExifTool variables)
+            $tag = $Image::ExifTool::specialTags{$key} ? "_$key" : $key;
+            # add to tag table if necessary
+            unless ($$tagTablePtr{$tag}) {
+                my $name = ucfirst lc $tag; # make tag name lower case with leading capital
+                $name =~ s/_(.)/\U$1/g;     # remove all '_' and capitalize subsequent letter
+                AddTagToTable($tagTablePtr, $tag, { Name => $name });
+            }
+        }
+        my $val = substr($buff, 10);
+        # parse quoted values
+        if ($val =~ /^'(.*?)'(.*)/) {
+            ($val, $buff) = ($1, $2);
+            while ($buff =~ /^('.*?)'(.*)/) {   # handle escaped quotes
+                $val .= $1;
+                $buff = $2;
+            }
+            $val =~ s/ +$//;            # remove trailing spaces
+            if (defined $continue) {
+                $val = $continue . $val;
+                undef $continue;
+            }
+            # check for possible continuation, removing trailing '&'
+            $val =~ s/\&$// and $continue = $val, next;
+        } elsif (defined $continue) {
+            $et->WarnOnce('Invalid FITS CONTINUE value');
+            next;
+        } else {
+            $val =~ s/ *(\/.*)?$//;     # remove trailing spaces and comment
+            next unless length $val;    # ignore undefined values
+            $val =~ s/^ +//;            # remove leading spaces
+            # re-format floating-point values to use 'e'
+            $val =~ tr/DE/e/ if $val =~ /^[+-]?(?=\d|\.\d)\d*(\.\d*)?([ED]([+-]?\d+))?$/;
+        }
+        $et->HandleTag($tagTablePtr, $tag, $val);
+    }
+    return 1;
+}
+
+1;  # end
+
+__END__
+
+=head1 NAME
+
+Image::ExifTool::FITS - Read Flexible Image Transport System metadata
+
+=head1 SYNOPSIS
+
+This module is used by Image::ExifTool
+
+=head1 DESCRIPTION
+
+This module contains definitions required by Image::ExifTool to read meta
+information from FITS (Flexible Image Transport System) images.
+
+=head1 AUTHOR
+
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
+
+This library is free software; you can redistribute it and/or modify it
+under the same terms as Perl itself.
+
+=head1 REFERENCES
+
+=over 4
+
+=item L<https://fits.gsfc.nasa.gov/fits_standard.html>
+
+=back
+
+=head1 SEE ALSO
+
+L<Image::ExifTool::TagNames/FITS Tags>,
+L<Image::ExifTool(3pm)|Image::ExifTool>
+
+=cut
+
